SystemOrganization addCategory: #ConfigurationOfInstanceEncoder!

Object subclass: #ConfigurationOfInstanceEncoder
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfInstanceEncoder'!

!ConfigurationOfInstanceEncoder class methodsFor: 'development support' stamp: 'HernanMoralesDurand 8/12/2013 10:15'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfInstanceEncoder class methodsFor: 'private' stamp: 'HernanMoralesDurand 8/12/2013 10:15'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfInstanceEncoder class methodsFor: 'private' stamp: 'HernanMoralesDurand 8/12/2013 10:15'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfInstanceEncoder class methodsFor: 'private' stamp: 'HernanMoralesDurand 8/12/2013 10:15'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfInstanceEncoder class methodsFor: 'metacello tool support' stamp: 'HernanMoralesDurand 8/12/2013 10:15'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfInstanceEncoder class methodsFor: 'loading' stamp: 'HernanMoralesDurand 8/12/2013 10:15'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfInstanceEncoder class methodsFor: 'loading' stamp: 'HernanMoralesDurand 8/12/2013 10:15'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfInstanceEncoder class methodsFor: 'loading' stamp: 'HernanMoralesDurand 8/12/2013 10:15'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfInstanceEncoder class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/12/2013 10:15'!
project

	^self new project! !

!ConfigurationOfInstanceEncoder class methodsFor: 'development support' stamp: 'HernanMoralesDurand 8/12/2013 10:15'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfInstanceEncoder methodsFor: 'baselines' stamp: 'HernanMoralesDurand 10/22/2013 20:50'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.smalltalkhub.com/mc/hernan/InstanceEncoder/main'.
		spec package: 'InstanceEncoder'.
		spec group: 'default' with: #('InstanceEncoder' ). ].
! !

!ConfigurationOfInstanceEncoder methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/12/2013 10:15'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfInstanceEncoder methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 10/22/2013 20:51'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.3'.
! !

!ConfigurationOfInstanceEncoder methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/12/2013 10:15'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfInstanceEncoder methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 10/22/2013 20:44'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.3'.
! !

!ConfigurationOfInstanceEncoder methodsFor: 'versions' stamp: 'HernanMoralesDurand 8/12/2013 10:15'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.0 :'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '8/12/2013 10:15'.
		spec package: 'InstanceEncoder' with: 'InstanceEncoder-HernanMoralesDurand.13'. ].
! !

!ConfigurationOfInstanceEncoder methodsFor: 'versions' stamp: 'HernanMoralesDurand 8/12/2013 10:16'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: '1.0 :'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '8/12/2013 10:15'.
		spec package: 'InstanceEncoder' with: 'InstanceEncoder-HernanMoralesDurand.13'. ].
! !

!ConfigurationOfInstanceEncoder methodsFor: 'versions' stamp: 'HernanMoralesDurand 8/14/2013 08:11'!
version12: spec
	<version: '1.2' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.2 : Release for Pharo 2.0. Helpers to encode and decode files or instances of any object that can be streamed to methods (either class or instance side). For example, did you ever want to store a graphic as a class side method so you can share your "external" or object instances using Monticello or other code-based sharing schemes? Well -- that is primarily what this is for. Any external file or object instance can be stuffed into a class method as a MIME-encoded zipped string.'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '8/12/2013 10:17'.
		spec package: 'InstanceEncoder' with: 'InstanceEncoder-HernanMoralesDurand.13'. ].
! !

!ConfigurationOfInstanceEncoder methodsFor: 'versions' stamp: 'HernanMoralesDurand 10/22/2013 20:44'!
version13: spec
	<version: '1.3' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: '1.2 : Release for Pharo 2.0'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '8/12/2013 10:17'.
		spec package: 'InstanceEncoder' with: 'InstanceEncoder-HernanMoralesDurand.13'. ].
! !
